;    AT90S2313 (Atmel).
;   OPTOSEVBSTOR2 
;  -  .
; 1. LAMP        0
; 2. OPTO      .

;*   1  2002.

;*****   
;    .	
.def    temp    =r20  
.def    temp1    =r21
.def    counter =r17     	
.def    counter1 =r18     	
.def    counter2    =r24
.def    counter3    =r23
.def    counter4    =r25
.def    counter5    =r19
;*****!

.equ	OPTO	=2		;   
.equ	LAMP	=0		;   
.equ	BUZ	=0              ;  ""
.include "2313def.inc"		; "" 



;                

;   
	rjmp 	reset 		
		
	rjmp	OPTO_ON		;EXT_INT0   ; IRQ0 Handler 
   	reti			;EXT_INT1   ; IRQ1 Handler  
	reti 			;TIM_CAPT1  ; Timer1 Capture Handler  
	reti 			;TIM_COMP1  ; Timer1 Compare Handler  
	reti 			;TIM_OVF1   ; Timer1 Overflow Handler  
	reti		 	;TIM_OVF0   ; Timer0 Overflow Handler 
	reti 			;UART_RXC   ; UART RX Complete Handler  
	reti 			;UART_DRE   ; UDR Empty Handler  
	reti 			;UART_TXC   ; UART TX Complete Handler  
	reti 			;ANA_COMP   ; Analog Comparator Handler  
reset:
	cli
	ldi	temp,RAMEND	;      
	out	SPL,temp	;        .
	

;   /

       	ldi	temp,0b11111111         
       	out     DDRB,temp       	
       	ldi	temp,0b11111111
        out     PORTB,temp	     	
       	ldi	temp,0b11111011		
       	out     DDRD,temp       	  
       	ldi	temp,0b11111111     	
       	out     PORTD,temp      	
   	
;          +5

	rcall 	BD_65
	
;  
	sei
	set
       	ldi	temp,0b01000000
       	out	GIMSK,temp		;   INT0
       	ldi	temp,0b00100000
       	out	MCUCR,temp
       	
       	;  	
	ldi	temp,0
LAMP_ON:	
	cbi	PORTB,LAMP	
	rcall 	BD_005			; 5 
	sbi 	PORTB,LAMP
	rcall 	BD_005			; 5 
	brtc	MAIN
	rjmp	LAMP_ON
	
;     
MAIN:	
	sbi 	PORTB,LAMP
MA:	sleep
	brts  	LAMP_ON
	rjmp	MA	


;////////////////////////////////////////////////////////////////////////////////////////////////	
;      
OPTO_ON:
	
	brtc	NON
	
	;   OPTO  .		
	ldi	counter3,14       		; 7mC
	ldi	temp,0
LAMP_ON_7MC:	
	dec	counter3
	cbi 	PORTB,LAMP	
	rcall 	BD_005_1			; 2.5 
	sbi	PORTB,LAMP
	rcall 	BD_005_1			; 
	cpse	counter3,temp
	rjmp	LAMP_ON_7MC
	;   
	sbis	PIND,OPTO
	rjmp	NEV		;   
	rcall	LAMP_ON_2C
	reti
;**************
NON:	
	;   OPTO  .
	ldi	counter3,14         		;7mC
BD_7MC:	
	dec	counter3
	nop
	nop	
	rcall 	BD_005_1			
	nop
	nop
	rcall 	BD_005_1			
	cpse	counter3,temp
	rjmp	BD_7MC
	;   
	sbis	PIND,OPTO
	rjmp	BUZER
	rcall	BD_2C
	reti
	
BUZER:	;    1 
	ldi 	counter4,15
BUZ_1C:	
	ldi	counter3,0
	dec	counter4
BUZ1_1C:	
	dec	counter3
	sbic	PIND,BUZ
	rjmp	AN
	sbi	PORTD,BUZ
	rjmp	AN1
AN:	cbi	PORTD,BUZ	
AN1:	rcall 	BD_005_1			; 5 
	nop
	nop
	rcall 	BD_005_1
	nop
	nop			; 5 
	cpse	counter3,temp
	rjmp	BUZ1_1C	
	cpse	counter4,temp
	rjmp	BUZ_1C
	;   1 .
	ldi 	counter4,2
BD_1C:	
	ldi	counter3,0
	dec	counter4
BD1_1C:	
	dec	counter3
	rcall 	BD_005_1
	nop
	nop					; 5 
	rcall 	BD_005_1
	nop
	nop			; 5 
	cpse	counter3,temp
	rjmp	BD1_1C	
	cpse	counter4,temp
	rjmp	BD_1C
	;   5     OPTO
	ldi 	counter4,30
BD_5C:	
	sbis	PIND,OPTO
	rjmp	BD1_7MC
	ldi	counter3,0
	dec	counter4
BD1_5C:	
	sbis	PIND,OPTO
	rjmp	BD1_7MC
	dec	counter3
	nop
	nop
	sbis	PIND,OPTO
	rjmp	BD1_7MC
	rcall 	BD_005_1
	nop			; 5 
	nop
	sbis	PIND,OPTO
	rjmp	BD1_7MC
	rcall 	BD_005_1			; 5 
	cpse	counter3,temp
	rjmp	BD1_5C	
	cpse	counter4,temp
	rjmp	BD_5C  
	rcall	BD_2C
	reti
	;   OPTO  .
	ldi	temp,0
BD1_7MC:	
	ldi	counter3,14         
BD1_7MC_1:	
	dec	counter3
	nop
	nop	
	rcall 	BD_005_1
	nop			; 5 
	nop
	rcall 	BD_005_1			; 5 
	cpse	counter3,temp
	rjmp	BD1_7MC_1
	;   
	sbic	PIND,OPTO		
	rjmp	BD_5C
	;  " !"	
	rcall	LAMP_ON_2C
	set
	reti	


;**************	
NEV:	;      1 
	ldi 	counter4,15
LAMP_ON_BUZ_1C:	
	ldi	counter3,0
	dec	counter4
LAMP_ON1_BUZ_1C:	
	dec	counter3
	sbic	PIND,BUZ
	rjmp	AN2
	sbi	PORTD,BUZ
	rjmp	AN3
AN2:	cbi 	PORTD,BUZ
AN3:	cbi 	PORTB,LAMP	
	rcall 	BD_005_1			; 5 
	sbi	PORTB,LAMP
	rcall 	BD_005_1			; 5 
	cpse	counter3,temp
	rjmp	LAMP_ON1_BUZ_1C	
	cpse	counter4,temp
	rjmp	LAMP_ON_BUZ_1C
	;    1 .
	ldi 	counter4,2
LAMP_ON_1C:	
	ldi	counter3,0
	dec	counter4
LAMP_ON1_1C:	
	dec	counter3
	cbi 	PORTB,LAMP
	rcall 	BD_005_1			; 5 
	sbi	PORTB,LAMP
	rcall 	BD_005_1			; 5 
	cpse	counter3,temp
	rjmp	LAMP_ON1_1C	
	cpse	counter4,temp
	rjmp	LAMP_ON_1C
	;    5     OPTO
	ldi 	counter4,30
LAMP_ON_5C:	
	ldi	counter3,0
	dec	counter4
LAMP_ON1_5C:	
	dec	counter3
	cbi 	PORTB,LAMP
	sbis	PIND,OPTO
	rjmp	LAMP_ONM_7MC
	rcall 	BD_005_1			; 5 
	sbi	PORTB,LAMP
	sbis	PIND,OPTO
	rjmp	LAMP_ONM_7MC
	rcall 	BD_005_1			; 5 
	cpse	counter3,temp
	rjmp	LAMP_ON1_5C	
	cpse	counter4,temp
	rjmp	LAMP_ON_5C
	rcall	LAMP_ON_2C
	reti
LAMP_ONM_7MC:	;   OPTO  .
	ldi	counter3,14         
LAMP_ON1_7MC:	
	dec	counter3
	cbi 	PORTB,LAMP	
	rcall 	BD_005_1			; 5 
	sbi	PORTB,LAMP
	rcall 	BD_005_1			; 5 
	cpse	counter3,temp
	rjmp	LAMP_ON1_7MC
	;   
	sbic	PIND,OPTO		
	rjmp	LAMP_ON1_5C
	; " !"
	clt
	rcall	BD_2C ;   
	reti
;//////////////////////////////////////////////////////////////////////////////////////////////////////	

;////////////////////////////////////////////////////////////////////////////////////////////////////
;**************
;**************
;**************
;**************
;**************
;**************	
BD_65:
	ldi     temp,0		;   
	ldi	counter2,20
	ldi     counter1,0		; 2.6c
	ldi     counter,0
BD_loop_65:
      	dec     counter		; 1   counter
      	cpse    counter,temp    ;  (   )
      	rjmp	BD_loop_65		;
	dec     counter1	; 1   counter2
      	cpse    counter1,temp   ;  (   )
      	rjmp	BD_loop_65      	;     
      	dec     counter2	; 1   counter2
      	cpse    counter2,temp   ;  (   )
      	rjmp	BD_loop_65      	;     		
      	ret			;
      		
BD_005:	
	ldi     temp,0		;   
	ldi     temp1,1	; 5 K 
	ldi     counter5,250	;97
BD_loop_005:
      	dec     counter5		; 1   counter
      	cpse    counter5,temp    ;  (   )
      	rjmp	BD_loop_005		;
	dec     temp1		; 1   counter2
      	cpse    temp1,temp   	;  (   )
      	rjmp	BD_loop_005      	;      		
      	ret
      				;
BD_005_1:	
	ldi     temp,0		;   
	ldi     counter1,1	; 5 K 
	ldi     counter,250	;97
BD_loop_005_1:
      	dec     counter		; 1   counter
      	cpse    counter,temp    ;  (   )
      	rjmp	BD_loop_005_1		;
	dec     counter1	; 1   counter2
      	cpse    counter1,temp   ;  (   )
      	rjmp	BD_loop_005_1      	;      		
      	ret			;   
	

      	
BD_2C:
	ldi     temp,0		;   
	ldi	counter2,20
	ldi     counter1,0		; 65
	ldi     counter,0
BD_loop_60:
      	dec     counter		; 1   counter
      	cpse    counter,temp    ;  (   )
      	rjmp	BD_loop_60		;
	dec     counter1	; 1   counter2
      	cpse    counter1,temp   ;  (   )
      	rjmp	BD_loop_60      	;     
      	dec     counter2	; 1   counter2
      	cpse    counter2,temp   ;  (   )
      	rjmp	BD_loop_60      	; 
      	ret
      	
LAMP_ON_2C:     	
	ldi 	counter4,20
LAMP_ON1_2C:	
	ldi	counter3,0
	dec	counter4
LAMP_ON2_2C:	
	dec	counter3
	cbi 	PORTB,LAMP
	rcall 	BD_005_1			; 5 
	sbi	PORTB,LAMP
	rcall 	BD_005_1			; 5 
	cpse	counter3,temp
	rjmp	LAMP_ON2_2C	
	cpse	counter4,temp
	rjmp	LAMP_ON1_2C
      	ret

